TimerGroupWindow2 = class(Turbine.UI.Window)
function TimerGroupWindow2:Constructor(objectParent, uiData, parent)
    group_data = {}

    for key, value in pairs(uiData) do
        group_data[key] = value
    end

	self.timerID = 0

	self.parent = objectParent

	self.layoutTable = {}
	-- overall settings
	self.layoutTable.Width = uiData.Timer_Width or 200
	self.layoutTable.Height = uiData.Timer_Height or 20
	self.layoutTable.Overall_Opacity = uiData.Overall_Opacity or 1
	self.layoutTable.Override_Opacity = uiData.Override_Opacity
	self.layoutTable.Increasing = uiData.Increasing
	self.layoutTable.Use_Warning = uiData.Use_Warning
	self.layoutTable.Warning_Colour = uiData.Warning_Colour or Turbine.UI.Color.Crimson
	self.layoutTable.Warning_Threshold = uiData.Warning_Threshold
	self.layoutTable.Background_Colour = uiData.Background_Colour
	self.layoutTable.Inactive_Opacity = uiData.Inactive_Opacity
	self.layoutTable.Highlight_Size = uiData.Highlight_Size

	-- bar settings
	self.layoutTable.Bar_Colour = uiData.Bar_Colour
	self.layoutTable.Bar_Background_Colour = uiData.Bar_Background_Colour
	self.layoutTable.Bar_Height_Percentage = uiData.Bar_Height_Percentage or 100
	self.layoutTable.Bar_Border_Size = uiData.Bar_Border_Size
	self.layoutTable.Bar_Border_Colour = uiData.Bar_Border_Colour
	self.layoutTable.Timer_Left_To_Right = uiData.Timer_Left_To_Right

	-- message settings
	self.layoutTable.Text = uiData.Text
	self.layoutTable.Original_Text = uiData.Original_Text
	self.layoutTable.Font = uiData.Font or Turbine.UI.Lotro.Font.FixedSys15
	self.layoutTable.Font_Colour = uiData.Font_Colour or Turbine.UI.Color.White
	self.layoutTable.Font_Outline = uiData.Font_Outline or Turbine.UI.FontStyle.Outline
	self.layoutTable.Font_Outline_Colour = uiData.Font_Outline_Colour or Turbine.UI.Color.Black
	self.layoutTable.MutliLine = uiData.MutliLine or false
	self.layoutTable.Text_Opacity = uiData.Text_Opacity or 1
	self.layoutTable.Text_Alignment = uiData.Text_Alignment or Turbine.UI.ContentAlignment.MiddleLeft

	-- duration settings
	self.layoutTable.Show_Duration = uiData.Show_Duration
	self.layoutTable.Duration_Font = uiData.Duration_Font or Turbine.UI.Lotro.Font.FixedSys15
	self.layoutTable.Duration_Font_Colour = uiData.Duration_Font_Colour or Turbine.UI.Color.White
	self.layoutTable.Duration_Font_Outline = uiData.Duration_Font_Outline or Turbine.UI.FontStyle.Outline
	self.layoutTable.Duration_Font_Outline_Colour = uiData.Duration_Font_Outline_Colour or Turbine.UI.Color.Black
	self.layoutTable.Duration_Opacity = uiData.Duration_Opacity
	self.layoutTable.Duration_Alignment = uiData.Duration_Alignment

	-- icon settings
	self.layoutTable.Show_Icon_Left = uiData.Show_Icon_Left
	self.layoutTable.Show_Icon_Right = uiData.Show_Icon_Right
	self.layoutTable.Icon = uiData.Icon
	self.layoutTable.Icon_Opacity = uiData.Icon_Opacity

	-- border settings
	self.layoutTable.Border_Size = uiData.Border_Size or 0
	self.layoutTable.Border_Colour = uiData.Border_Colour or Turbine.UI.Color.Black
	self.layoutTable.Border_Opacity = uiData.Border_Opacity or 1


    self.width = group_data.Width or 100
    self.height = group_data.Height or 100
    self.x = 0--data.X
    self.y = 0--data.Y
    self.timerDirection = group_data.Timer_Stack_Direction
    self.sortOrder = group_data.Timer_Sorting

    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)
    self:SetSize(self.width, self.height)
    self:SetPosition(self.x, self.y)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetBackColor(Turbine.UI.Color.Red)

    self.itemID = 0

    self.timers = {}
	self.staticTimers = {}
    self.staticSortOrder = {}

    self.staticMode = group_data.Static

    self.TimerListBox = Turbine.UI.ListBox()
    self.TimerListBox:SetParent(parent)
    self.TimerListBox:SetSize(self.width, self.height)
    self.TimerListBox:SetMouseVisible(false)
    self.TimerListBox:SetVisible(true)
    self.TimerListBox:SetOrientation(Turbine.UI.Orientation[group_data.Orientation])
    self.TimerListBox:SetFlippedLayout(group_data.Flipped_Layout)
    self.TimerListBox:SetReverseFill(group_data.Reverse_Fill)
    self.TimerListBox:SetMaxColumns(group_data.Max_Columns or 99)
    self.TimerListBox:SetMaxRows(group_data.Max_Rows or 99)

    if uiData.Timer_Sort_Override then
        self.sortMethod = function(a, b) 
            if a.Sort_Order_Override == b.Sort_Order_Override then
                return a.itemID > b.itemID
            else
                return a.Sort_Order_Override < b.Sort_Order_Override
            end
            
        end
    elseif self.sortOrder == "Alphabetical" then
        self.sortMethod = function(a, b) 
            if a:GetText() == b:GetText() then
                return a.itemID < b.itemID
            else
                return a:GetText() < b:GetText()
            end
            
        end
    elseif self.sortOrder == "Alphabetical Reverse" then
        self.sortMethod = function(a, b) 
            if a:GetText() == b:GetText() then
                return a.itemID < b.itemID
            else
                return a:GetText() > b:GetText()
            end
        end
    elseif self.sortOrder == "Low to High (Remaining duration)" then
        self.sortMethod = function(a, b) 
            if a:GetRemainingTime() == b:GetRemainingTime() then
                return a.itemID < b.itemID
            else
                return a:GetDuration() < b:GetDuration()
            end
        end
    elseif self.sortOrder == "High to Low (Max duration)" then
        self.sortMethod = function(a, b) 
            if a:GetMaxDuration() == b:GetMaxDuration() then
                return a.itemID < b.itemID
            else
                return a:GetMaxDuration() > b:GetMaxDuration()
            end
        end
    elseif self.sortOrder == "Low to High (Max duration)" then
        self.sortMethod = function(a, b) 
            if a:GetMaxDuration() == b:GetMaxDuration() then
                return a.itemID < b.itemID
            else
                return a:GetMaxDuration() < b:GetMaxDuration()
            end
        end
    else -- High to Low (Remaining duration)
        self.sortMethod = function(a, b) 
            if a:GetRemainingTime() == b:GetRemainingTime() then
                return a.itemID < b.itemID
            else
                return a:GetRemainingTime() > b:GetRemainingTime()
            end
        end
    end

end

-- Returning true means the we can create a timer according to the unique constraints
function TimerGroupWindow2:UniqueCheck(code, args)
	if self.timers[code] then
		if args.Unique then
			return not (tablelength(self.timers[code]) > 0)
		else

			local newTimerText =  args.Unique_By_Text and self:TextReplacementFunction(args.Text, args) or ""
			for key, value in pairs(self.timers[code]) do
			
				if args.Unique_By_Text and newTimerText == value.Timer:GetText() then
					return false
				end
	
				if args.Unique_By_Trigger and args.Trigger_Type == value.Trigger_Type then
					return false
				end

				if args.Unique_By_Source and args.Source == value.Source then
					return false
				end
			end
			return true
		end
	else
		return true
	end
end

function TimerGroupWindow2:OverrideCheck(code, args)
	if self.timers[code] then
		if self.timers[code] then
			if args.Override then
				local id_list = {}
				for key, value in pairs(self.timers[code]) do
					id_list[key] = true
				end
				return id_list
			else
	
				local newTimerText =  args.Override_By_Text and self:TextReplacementFunction(args.Text, args) or ""
				local id_list = {}
				for key, value in pairs(self.timers[code]) do
				
					if args.Override_By_Text and newTimerText == value.Timer:GetText() then
						id_list[key] = true
					end
		
					if args.Override_By_Trigger and args.Trigger_Type == value.Trigger_Type then
						id_list[key] = true
					end
	
					if args.Override_By_Source and args.Source == value.Source then
						id_list[key] = true
					end
				end
				return id_list
			end
		else
			return {}
		end
	end

	return {}
end

function TimerGroupWindow2:Trigger(code, args, timerData)
	if not self.timers[code] then self.timers[code] = {} end

	local sameCodeTimers = self.timers[code]
	local hasSameCodeTimers = tablelength(sameCodeTimers) > 0

	args.Static = timerData.Always_Visible

	-- Timer - start een timer
	if args.Timer then
		local no_uniques_encountered = self:UniqueCheck(code, args)
		
		if no_uniques_encountered then

			-- Als er een timer al bestaat die overschreven moet worden
			local override_timer_id = self:OverrideCheck(code, args)

			if not timerData.Always_Visible and tablelength(override_timer_id) > 0 then
				if timerData.Apply_Max_Timer_Instances_To_Override then

					if tablelength(override_timer_id) + 1 > (timerData.Max_Timer_Instances or 99999) then
						local timersToBeDeleted = tablelength(override_timer_id) - (timerData.Max_Timer_Instances or 99999) - 1
						for key, value in spairs(override_timer_id, function(t, a, b) return self.timers[a].Timer.itemID < self.timers[b].Timer.itemID end) do
							self:RemoveTimer(key, self.timers[key].Timer.itemID)

							if timersToBeDeleted <= 0 then 
								break
							end
						end
					end
				else
					for key, value in pairs(override_timer_id) do
						self:RemoveTimer(code, key)
					end
				end
			end

			if self.staticTimers[code] or (args.Add or args.Substract) and hasSameCodeTimers then
				for key, value in pairs(sameCodeTimers) do
					value.Timer:Trigger(args)
				end
			else
				if not timerData.Always_Visible and not timerData.Apply_Max_Timer_Instances_To_Override then
					if tablelength(self.timers[code]) + 1 > (timerData.Max_Timer_Instances or 99999) then
						local timersToBeDeleted = tablelength(self.timers[code]) - (timerData.Max_Timer_Instances or 99999) - 1
						for key, value in spairs(self.timers[code], function(t, a, b) return t[a].Timer.itemID < t[b].Timer.itemID end) do
							self:RemoveTimer(code, value.Timer.itemID)

							if timersToBeDeleted <= 0 then 
								break
							end
						end
					end
				end

				local timer = self:CreateTimer(code, args, timerData)
				timer:Trigger(args)
			end

			--self:Trigger_Internal(code, args)
		end
	elseif args.Remove_Timer then
		for key, value in pairs(self.timers[code]) do
			self:RemoveTimer(code, key)
		end
	else
		self:Trigger_Internal(code, args)
	end

	self.TimerListBox:Sort(self.sortMethod)
end

function TimerGroupWindow2:Trigger_Internal(code, args)
	if self.timers[code] then
		for key, value in pairs(self.timers[code]) do
			if args.unique_by_text and args.text == value.Timer:GetText() or 
			args.unique_by_trigger and args.trigger_type == value.Trigger_Type or 
			not args.unique_by_text and not args.unique_by_trigger then
				value.Timer:Trigger(args)
			end
		end
	end
end

function TimerGroupWindow2:Create_Static_Timer(code, timerData)
	if not self.timers[code] then self.timers[code] = {} end
	timerData.Always_Visible = true
	self:CreateTimer(code, {}, timerData)
	self.staticTimers[code] = true
	self.TimerListBox:Sort(self.sortMethod)
end

function TimerGroupWindow2:CreateTimer(code, args, timerData)
	local layoutTable = {}

	if timerData.Use_Timer_Style then
		-- overall settings
		layoutTable.Width = timerData.Width or 200
		layoutTable.Height = timerData.Height or 20
		layoutTable.Overall_Opacity = timerData.Overall_Opacity or 1
		layoutTable.Override_Opacity = timerData.Override_Opacity
		layoutTable.Increasing = timerData.Increasing
		layoutTable.Use_Warning = timerData.Use_Warning
		layoutTable.Warning_Colour = timerData.Warning_Colour or Turbine.UI.Color.Crimson
		layoutTable.Warning_Threshold = timerData.Warning_Threshold
		layoutTable.Background_Colour = timerData.Background_Colour
		layoutTable.Always_Visible = timerData.Always_Visible
		layoutTable.Inactive_Opacity = timerData.Inactive_Opacity

		-- bar settings
		layoutTable.Bar_Colour = timerData.Bar_Colour
		layoutTable.Bar_Background_Colour = timerData.Bar_Background_Colour
		layoutTable.Bar_Height_Percentage = timerData.Bar_Height_Percentage or 100
		layoutTable.Bar_Border_Size = timerData.Bar_Border_Size
		layoutTable.Bar_Border_Colour = timerData.Bar_Border_Colour
		layoutTable.Timer_Left_To_Right = timerData.Timer_Left_To_Right

		-- message settings
		layoutTable.Text = timerData.Text
		layoutTable.Original_Text = timerData.Original_Text
		layoutTable.Font = timerData.Font or Turbine.UI.Lotro.Font.FixedSys15
		layoutTable.Font_Colour = timerData.Font_Colour or Turbine.UI.Color.White
		layoutTable.Font_Outline = timerData.Font_Outline or Turbine.UI.FontStyle.Outline
		layoutTable.Font_Outline_Colour = timerData.Font_Outline_Colour or Turbine.UI.Color.Black
		layoutTable.MutliLine = timerData.MutliLine or false
		layoutTable.Text_Opacity = timerData.Text_Opacity or 1
		layoutTable.Text_Alignment = timerData.Text_Alignment or Turbine.UI.ContentAlignment.MiddleLeft

		-- duration settings
		layoutTable.Show_Duration = timerData.Show_Duration
		layoutTable.Duration_Font = timerData.Duration_Font or Turbine.UI.Lotro.Font.FixedSys15
		layoutTable.Duration_Font_Colour = timerData.Duration_Font_Colour or Turbine.UI.Color.White
		layoutTable.Duration_Font_Outline = timerData.Duration_Font_Outline or Turbine.UI.FontStyle.Outline
		layoutTable.Duration_Font_Outline_Colour = timerData.Duration_Font_Outline_Colour or Turbine.UI.Color.Black
		layoutTable.Duration_Opacity = timerData.Duration_Opacity
		layoutTable.Duration_Alignment = timerData.Duration_Alignment

		-- icon settings
		layoutTable.Show_Icon_Left = timerData.Show_Icon_Left
		layoutTable.Show_Icon_Right = timerData.Show_Icon_Right
		layoutTable.Icon = timerData.Icon
		layoutTable.Icon_Opacity = timerData.Icon_Opacity

		-- border settings
		layoutTable.Border_Size = timerData.Border_Size or 0
		layoutTable.Border_Colour = timerData.Border_Colour or Turbine.UI.Color.Black
		layoutTable.Border_Opacity = timerData.Border_Opacity or 1

		layoutTable.Base_Text = timerData.Base_Text
		layoutTable.Timer_Icon = timerData.Timer_Icon

		layoutTable["Always_Visible"] = timerData.Always_Visible
		layoutTable["Sort_Order_Override"] = timerData.Sort_Order_Override
		layoutTable["Max_Timer_Instances"] = timerData.Max_Timer_Instances
		layoutTable["Apply_Max_Timer_Instances_To_Override"] = timerData.Apply_Max_Timer_Instances_To_Override
	end

	local timer = UI.Timer2(nil, timerData.Use_Timer_Style and layoutTable or self.layoutTable)

	self.TimerListBox:AddItem(timer)

	local timerID = self.timerID

	timer.itemID = timerID
	timer.Sort_Order_Override = timerData.Sort_Order_Override
	AddCallback(timer, "TimerEnded", 
	function() 
		if not timerData.Always_Visible then
			self:RemoveTimer(code, timerID)  
		else
			self:ResetTimer(code, timerID, timerData)
		end

		if args.Event_List then
			self:FireTrigger(args)
		end
	end)

	self.timers[code][self.timerID] = {["Timer"] = timer, ["Trigger_Type"] = args.trigger_type or "", ["Source"] = args.Source or ""}

	if timerData.Always_Visible or layoutTable.Always_Visible then 
		timer.static_timer = true
		self:ResetTimer(code, self.timerID, timerData) 
	end

	self.timerID = self.timerID + 1

	return timer
end

function TimerGroupWindow2:ResetTimer(code, id, args)
	if self.timers[code] and self.timers[code][id] then
		local timer = self.timers[code][id].Timer

		timer:Reset(args, args.Base_Text, args.Timer_Icon)
	end
end

function TimerGroupWindow2:RemoveTimer(code, id)
	if self.timers[code] and self.timers[code][id] then
		local timer = self.timers[code][id].Timer

		self.TimerListBox:RemoveItem(timer)

		timer:Unload()

		self.timers[code][id] = nil
	end
end

function TimerGroupWindow2:FireTrigger(args)
	for event in string.gmatch(args.Event_List, "([^,]+)") do
		self.parent:FireTrigger(event, args or {})
	end
end

function TimerGroupWindow2:TextReplacementFunction(text, args)
	return ReplaceTokens(string.gsub(text or "", "<name>", NameHandlerObject:GetName(args.Name or "", true, "TimerGroup2", "") or ""), args or {})
end

function TimerGroupWindow2:Unload()
	self.staticTimers = {}
    for i = 1, self.TimerListBox:GetItemCount() do
        self.TimerListBox:GetItem(i):SetVisible(false)
    end
    self.TimerListBox:ClearItems()
	for key, value in pairs(self.timers) do
		for k, v in pairs(value) do
			v.Timer:Unload()
		end
	end
    self.timers = nil
end